<?php
/**
 *
 * @category        frontend
 * @package         page
 * @author          WebsiteBaker Project
 * @copyright       2009-, Website Baker Org. e.V.
 * @link			http://www.websitebaker2.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.2.2 and higher
 * @version         $Id: index.php 1520 2011-11-09 00:12:37Z darkviper $
 * @filesource		$HeadURL: svn://isteam.dynxs.de/wb_svn/wb280/tags/2.8.3/wb/index.php $
 * @lastmodified    $Date: 2011-11-09 01:12:37 +0100 (Mi, 09. Nov 2011) $
 *
 */

$starttime = array_sum(explode(" ",microtime()));

define('DEBUG', false);
// Include config file
$config_file = dirname(__FILE__).'/config.php';
if(file_exists($config_file))
{
	require_once($config_file);
}

require_once(WB_PATH.'/framework/class.frontend.php');
// Create new frontend object
$wb = new frontend();

// Figure out which page to display
// Stop processing if intro page was shown
$wb->page_select() or die();

// Collect info about the currently viewed page
// and check permissions
get_page_details();
function get_page_details() {
		global $database, $wb;
	    if($wb->page_id != 0) {echo $wb->page_id."  wwww";
			// Query page details
			$sql = 'SELECT * FROM `'.TABLE_PREFIX.'pages` WHERE `page_id`='.(int)$wb->page_id;
			$get_page = $database->query($sql);
			// Make sure page was found in database
			if($get_page->numRows() == 0) {
				// Print page not found message
				exit("Page not found");
			}
			// Fetch page details
			$wb->page = $get_page->fetchRow();
			// Check if the page language is also the selected language. If not, send headers again.
			if ($wb->page['language']!=LANGUAGE) {
				if(isset($_SERVER['QUERY_STRING']) && $_SERVER['QUERY_STRING'] != '') { // check if there is an query-string
					header('Location: '.$wb->page_link($wb->page['link']).'?'.$_SERVER['QUERY_STRING'].'&lang='.$wb->page['language']);
				} else {
					header('Location: '.$wb->page_link($wb->page['link']).'?lang='.$wb->page['language']);
				}
				exit();
			}
			// Begin code to set details as either variables of constants
			// Page ID
			if(!defined('PAGE_ID')) {define('PAGE_ID', $wb->page['page_id']);}
			echo PAGE_ID."  rr55555555";
			// Page Title
			if(!defined('PAGE_TITLE')) {define('PAGE_TITLE', $wb->page['page_title']);}
			$wb->page_title=PAGE_TITLE;
			// Menu Title
			$menu_title = $wb->page['menu_title'];
			if($menu_title != '') {
				if(!defined('MENU_TITLE')) {define('MENU_TITLE', $menu_title);}
			} else {
				if(!defined('MENU_TITLE')) {define('MENU_TITLE', PAGE_TITLE);}
			}
			$wb->menu_title = MENU_TITLE;
			// Page parent
			if(!defined('PARENT')) {define('PARENT', $wb->page['parent']);}
			$wb->parent=$wb->page['parent'];
			// Page root parent
			if(!defined('ROOT_PARENT')) {define('ROOT_PARENT', $wb->page['root_parent']);}
			$wb->root_parent=$wb->page['root_parent'];
			// Page level
			if(!defined('LEVEL')) {define('LEVEL', $wb->page['level']);}
			$wb->level=$wb->page['level'];
			// Page position
			$wb->level=$wb->page['position'];
			// Page visibility
			if(!defined('VISIBILITY')) {define('VISIBILITY', $wb->page['visibility']);}
			$wb->visibility=$wb->page['visibility'];
			// Page trail
			foreach(explode(',', $wb->page['page_trail']) AS $pid) {
				$wb->page_trail[$pid]=$pid;
			}
			// Page description
			$wb->page_description=$wb->page['description'];
			if($wb->page_description != '') {
				define('PAGE_DESCRIPTION', $wb->page_description);
			} else {
				define('PAGE_DESCRIPTION', WEBSITE_DESCRIPTION);
			}
			// Page keywords
			$wb->page_keywords=$wb->page['keywords'];
			// Page link
			$wb->link=$wb->page_link($wb->page['link']);
			$_SESSION['PAGE_ID'] = $wb->page_id;
			$_SESSION['HTTP_REFERER'] = $wb->link;

		// End code to set details as either variables of constants
		}

		// Figure out what template to use
		if(!defined('TEMPLATE')) {
			if(isset($wb->page['template']) AND $wb->page['template'] != '') {
				if(file_exists(WB_PATH.'/templates/'.$wb->page['template'].'/index.php')) {
					define('TEMPLATE', $wb->page['template']);
				} else {
					define('TEMPLATE', DEFAULT_TEMPLATE);
				}
			} else {
				define('TEMPLATE', DEFAULT_TEMPLATE);
			}
		}
		// Set the template dir
		define('TEMPLATE_DIR', WB_URL.'/templates/'.TEMPLATE);

		// check if there is at least one active section
		if($wb->page && $wb->page_is_active($wb->page) == false) {
			$wb->page_no_active_sections=true;
		}
	}



// Collect general website settings
$wb->get_website_settings();

// Load functions available to templates, modules and code sections
// also, set some aliases for backward compatibility
require(WB_PATH.'/framework/frontend.functions.php');

// redirect menu-link
$wb_page_id = PAGE_ID;

$php43 = version_compare(phpversion(), '4.3', '>=');

$sql  = 'SELECT `module`, `block` FROM `'.TABLE_PREFIX.'sections` ';
$sql .= 'WHERE `page_id` = '.(int)$wb_page_id.' AND `module` = "menu_link"';
$query_this_module = $database->query($sql);
if($query_this_module->numRows() == 1)  // This is a menu_link. Get link of target-page and redirect
{
	// get target_page_id
	$sql  = 'SELECT * FROM `'.TABLE_PREFIX.'mod_menu_link` WHERE `page_id` = '.(int)$wb_page_id;
	$query_tpid = $database->query($sql);
	if($query_tpid->numRows() == 1)
	{
		$res = $query_tpid->fetchRow();
		$target_page_id = $res['target_page_id'];
		$redirect_type = $res['redirect_type'];
		$anchor = ($res['anchor'] != '0' ? '#'.(string)$res['anchor'] : '');
		$extern = $res['extern'];
		// set redirect-type
		if($redirect_type == 301)
		{
			if($php43)
			{
				@header('HTTP/1.1 301 Moved Permanently', TRUE, 301);
			}
			else
			{
				@header('HTTP/1.1 301 Moved Permanently');
			}
		}
		if($target_page_id == -1)
		{
			if($extern != '')
			{
				$target_url = $extern.$anchor;
				header('Location: '.$target_url);
				exit;
			}
		}
		else
		{
			// get link of target-page
			$sql  = 'SELECT `link` FROM `'.TABLE_PREFIX.'pages` WHERE `page_id` = '.$target_page_id;
			$target_page_link = $database->get_one($sql);
			if($target_page_link != null)
			{
				$target_url = WB_URL.PAGES_DIRECTORY.$target_page_link.PAGE_EXTENSION.$anchor;
				header('Location: '.$target_url);
				exit;
			}
		}
	}
}
//Get pagecontent in buffer for Droplets and/or Filter operations
ob_start();
require(WB_PATH.'/templates/'.TEMPLATE.'/index.php');
$output = ob_get_contents();
if(ob_get_length() > 0) { ob_end_clean(); }

// wb->preprocess() -- replace all [wblink123] with real, internal links
// if( method_exists($wb, 'preprocess') )
// {
   // $wb->preprocess($output);
// }

// Load Droplet engine and process
	if(file_exists(WB_PATH .'/modules/droplets/droplets.php')) {
		include_once(WB_PATH .'/modules/droplets/droplets.php');
		if(function_exists('evalDroplets')) {
			$output = evalDroplets($output);
		}
	}

// Load backwards compatible frontend filter support and process
	if(file_exists(WB_PATH .'/modules/output_filter/filter-routines.php')) {
		include_once(WB_PATH .'/modules/output_filter/filter-routines.php');
		if(function_exists('executeFrontendOutputFilter')) {
			$output = executeFrontendOutputFilter($output);			
		}elseif(function_exists('filter_frontend_output')) {
			$output = filter_frontend_output($output);
		}

	}

// move css definitions into head section
	if(function_exists('moveCssToHead')) {
		$output = moveCssToHead($output);
	}
// now send complete page to the browser
echo $output;
// end of wb-script
exit;
