<?php

use bin\{WbAdaptor,SecureTokens};
use bin\helpers\{PreCheck,msgQueue};
/*

 Website Baker Project <http://www.websitebaker.org/>
 Copyright (C) 2004-2008, Ryan Djurovich

 Website Baker is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 Website Baker is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Website Baker; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

// Include config file
require('../../config.php');


// Include wb class
//require_once(WB_PATH.'/framework/class.wb.php');
//$wb = new wb('Start', 'start', false, false);
// Include WB functions file
//require_once(WB_PATH.'/framework/functions.php');
// Create new frontend object

    if (!function_exists('ObfuscateIp')) {
        function ObfuscateIp() {
            $sClientIp = (isset($_SERVER['REMOTE_ADDR']))
                                 ? $_SERVER['REMOTE_ADDR'] : '000.000.000.000';
            $iClientIp = ip2long($sClientIp);
            $sClientIp = long2ip(($iClientIp & ~65535));
            return $sClientIp;
        }
    }

$page_id = (int)($_GET['pid'] ?? false);
$section_id = (int)($_GET['sid'] ?? false);

if (($page_id === false) || ($section_id === false)){
    die('Missing Parameter');
}

// Create missing frontend object
if (!isset($wb) || (isset($wb) && !($wb instanceof \frontend))) {$wb = new \frontend();}

$oReg = WbAdaptor::getInstance();

// check if module language file exists for the language set by the user (e.g. DE, EN)
if (\is_readable(__DIR__.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
if (\is_readable(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
if (\is_readable(__DIR__.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}

        // fetch guestbook-URL look for shorturl too
        $link = $wb->getPageLink($page_id);

/*
if(file_exists(WB_PATH .'/modules/guestbook/languages/'.LANGUAGE .'.php')) {
        require_once(WB_PATH .'/modules/guestbook/languages/'.LANGUAGE .'.php');
} else {
        require_once(WB_PATH .'/modules/guestbook/languages/EN.php');
}
*/
// load geoip-database, if available
if(file_exists(WB_PATH.'/modules/geoip/geoip_functions.php')) {
        require_once(WB_PATH.'/modules/geoip/geoip_functions.php');
        $gi = geoip_open_db(); // defines constant GEOIP_DATABASE_LOADED on success
}

// Validation:                Check if details are correct. If not navigate to main.
if(!(
        isset($_GET['sid']) && is_numeric($_GET['sid'])
        && isset($_GET['pid']) && is_numeric($_GET['pid'])
        && isset($_POST['u_name']) && $_POST['u_name']!=''
        && (
                (defined('ENABLED_ASP') && ENABLED_ASP && isset($_POST['me55age_'.date('W')]) && $_POST['me55age_'.date('W')] != '')
                || (((defined('ENABLED_ASP') && !ENABLED_ASP) || !defined('ENABLED_ASP')) && isset($_POST['message']) && $_POST['message'] != '')
        ))) {
        header('Location: '.WB_URL.'/index.php'); 
        exit();
}

// fetch values from $_POST[], clean values
// name
$name_clean_html = htmlspecialchars(strip_tags($wb->strip_slashes($_POST['u_name'])),ENT_QUOTES);
$name_clean_db   = addslashes(htmlspecialchars(strip_tags($wb->strip_slashes($_POST['u_name'])),ENT_QUOTES));
if ($name_clean_html=='') {
        $name_clean_html = $name_clean_db = 'unknown';
}
// homepage
$homepage_clean_html = htmlspecialchars(strip_tags($wb->strip_slashes($_POST['homepage'])),ENT_QUOTES);
$homepage_clean_db   = addslashes(htmlspecialchars(strip_tags($wb->strip_slashes($_POST['homepage'])),ENT_QUOTES));
if ($homepage_clean_html=='http://www.') {
        $homepage_clean_html = $homepage_clean_db = '';
}
// email
$email_clean_html = htmlspecialchars(strip_tags($wb->strip_slashes($_POST['email'])),ENT_QUOTES);
$email_clean_db   = addslashes(htmlspecialchars(strip_tags($wb->strip_slashes($_POST['email'])),ENT_QUOTES));
// message
if(defined('ENABLED_ASP') && ENABLED_ASP)
        $tmp = $_POST['me55age_'.date('W')];
else
        $tmp = $_POST['message'];

$message_tainted = $tmp; // ATTN: $message_tainted is NOT cleaned - used in bancheck-module
$message_clean_html = htmlspecialchars(strip_tags($wb->strip_slashes($tmp)),ENT_QUOTES);
$message_clean_db   = addslashes(htmlspecialchars(strip_tags($wb->strip_slashes($tmp)),ENT_QUOTES));
unset($tmp);
if($message_clean_html=='') {
        $message_clean_html = $message_clean_db = $message_tainted = '-empty-';
}

// fetch ip-addr
if (defined('GEOIP_DATABASE_LOADED')){
    $ip_addr = geoip_best_ip();
} else {
    $ip_addr = ObfuscateIp();
}

if (file_exists(WB_PATH.'/modules/ban/bancheck.php')) {
        $bancheckvar=$message_tainted;
        include WB_PATH.'/modules/ban/bancheck.php';
}

// Advanced Spam Protection
$t = time();
/* */
if (defined('ENABLED_ASP') && ENABLED_ASP && (
        ($_SESSION['session_started']+ASP_SESSION_MIN_AGE > $t) OR // session too young
        (!isset($_SESSION['comes_from_view_gb'])) OR // user doesn't come from view.php
        (!isset($_SESSION['comes_from_view_gb_time']) OR $_SESSION['comes_from_view_gb_time'] > $t-ASP_INPUT_MIN_AGE) OR // user is too fast
        (!isset($_SESSION['submitted_when']) OR !isset($_POST['submitted_when'])) OR // faked form
        ($_SESSION['submitted_when'] != $_POST['submitted_when']) OR // faked form
        ($_SESSION['submitted_when'] < $t-43200) OR // form older than 12h
        (!isset($_POST['email-address']) || $_POST['email-address']!='' OR
         !isset($_POST['url']) || $_POST['url']!='' OR
         !isset($_POST['name']) || $_POST['name']!='' OR
         !isset($_POST['comment']) || $_POST['comment']!='') // honeypot-fields
)) {
        header('Location: '.WB_URL.'/index.php'); 
        exit();
}

// Retrieve settings
$query_settings = $database->query("SELECT * FROM `".TABLE_PREFIX."mod_guestbook_settings` WHERE `section_id` = '".$section_id."'");
$settings = $query_settings->fetchRow();
$use_captcha = $settings['use_captcha'];
$auto_approve = $settings['auto_approve'];
$admin_email = $settings['admin_email'];
$store_server_vars = $settings['store_server_vars'];

// Captcha
if( (extension_loaded('gd') && function_exists('imageCreateFromJpeg')) /* Make's sure GD library is installed (for wb <2.7)*/
        || file_exists(WB_PATH.'/include/captcha/captcha.php') ) { /* wb2.7 */
        $sCaptchaId = 99;
        if($use_captcha) {
                if(isset($_POST['captcha99']) AND $_POST['captcha99'] != ''){
                        // Check for a mismatch
                        if(!isset($_POST['captcha'.$sCaptchaId]) OR !isset($_SESSION['captcha'.$sCaptchaId]) OR $_POST['captcha'.$sCaptchaId] != $_SESSION['captcha'.$sCaptchaId]) {
                                $captcha_error = $MESSAGE['MOD_FORM_INCORRECT_CAPTCHA'];
                        }
                } else {
                        $captcha_error = $MESSAGE['MOD_FORM_INCORRECT_CAPTCHA'];
                }
        }
}

if(isset($_SESSION['captcha'.$sCaptchaId])) {unset($_SESSION['captcha'.$sCaptchaId]);}

if(isset($captcha_error)) {
        $_SESSION['gb']['message'] = $message_clean_html;
        $_SESSION['gb']['email'] = $email_clean_html;
        $_SESSION['gb']['homepage'] = $homepage_clean_html;
        $_SESSION['gb']['name'] = $name_clean_html;
        header('Location: '.WB_URL."/modules/guestbook/gstbk_add.php?sid=$section_id&pid=$page_id&add=".(int)$_SESSION['comes_from_view_gb']."&captcha=true"); 
        exit();

} else {

        if(isset($_SESSION['gb'])) {
                unset($_SESSION['gb']);
        }
        if(defined('ENABLED_ASP') && ENABLED_ASP) {
                unset($_SESSION['comes_from_view_gb']);
                unset($_SESSION['comes_from_view_gb_time']);
                unset($_SESSION['submitted_when']);
        }


        // get position
        // Include the ordering class
//        require(WB_PATH.'/framework/class.order.php');
        $order = new order(TABLE_PREFIX."mod_guestbook", 'position', 'id', 'section_id');
        $position = $order->get_new($section_id);
        $entry_when = time();

        // store server-vars?
        $server_vars = '';
        if($store_server_vars) {
                foreach($_SERVER as $k=>$v) {
                        if(is_array($v)) continue;
                        $var = htmlspecialchars($k, ENT_QUOTES);
                        $val = htmlspecialchars($v, ENT_QUOTES);
                        $server_vars .= "<strong>$var</strong> = $val<br />";
                        $server_vars = addslashes($server_vars);
                }
        }


        $sql = 'INSERT INTO `'.TABLE_PREFIX.'mod_guestbook` SET '
              .'`page_id` = '.(int)$page_id.', '
              .'`section_id` = '.(int)$section_id.', '
              .'`name`  = \''.$database->escapeString($name_clean_db).'\', '
              .'`email` = \''.$database->escapeString($email_clean_db).'\', '
              .'`homepage` = \''.$database->escapeString($homepage_clean_db).'\', '
              .'`message` = \''.$database->escapeString($message_clean_db).'\', '
              .'`comment` = \'\', '
              .'`posted_when` = '.(int)$entry_when.', '
              .'`position` = '.(int)$position.', '
              .'`approved` = \''.$database->escapeString($auto_approve).'\', '
              .'`ip_addr`  = \''.$database->escapeString($ip_addr).'\', '
              .'`server_vars` = \''.$database->escapeString($server_vars).'\' ';
        $database->query($sql);

        if($database->is_error()){
          echo nl2br(sprintf("Error: %s \n %s \n",$sql,$database->get_error()));
        } else {
/*
        // fetch guestbook-URL
        $link = WB_URL;
        if($query_link = $database->query("SELECT `link` FROM `".TABLE_PREFIX."pages` WHERE `page_id` = '$page_id'"))
                if($row = $query_link->fetchRow())
                        $link = WB_URL.PAGES_DIRECTORY.$row['link'].PAGE_EXTENSION;
*/

        //send mail
        if($admin_email!=''){
                $mail_subject = $MOD_GUESTBOOK['MAILSUBJECT'];
                $mail_message = $MOD_GUESTBOOK['MAILMESSAGE'];
                // append link to message
                $mail_message .= "<a href=\"$link\" target=\"_blank\">$link</a>";
                // add guestbook-text to message
                $mail_message .= "\r\n\r\n$name_clean_html [$ip_addr] ($email_clean_html - $homepage_clean_html)\r\n$message_clean_html";
                $wb->mail(SERVER_EMAIL,$admin_email,$mail_subject,$mail_message);
        }

        // close geoip-database
        if(defined('GEOIP_DATABASE_LOADED')){
                geoip_close($gi);
        }

                // jump back to guestbook
//                exit(header("Location: $link"));
                header("Location: $link"); 
                exit();
    }
}
